Assistants
List assistants
get /assistants
Returns a list of assistants.
Query Parameters
-
after: optional stringA cursor for use in pagination.
afteris an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, ending with obj_foo, your subsequent call can include after=obj_foo in order to fetch the next page of the list. -
before: optional stringA cursor for use in pagination.
beforeis an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, starting with obj_foo, your subsequent call can include before=obj_foo in order to fetch the previous page of the list. -
limit: optional numberA limit on the number of objects to be returned. Limit can range between 1 and 100, and the default is 20.
-
order: optional "asc" or "desc"Sort order by the
created_attimestamp of the objects.ascfor ascending order anddescfor descending order.-
"asc" -
"desc"
-
Returns
-
data: array of Assistant-
id: stringThe identifier, which can be referenced in API endpoints.
-
created_at: numberThe Unix timestamp (in seconds) for when the assistant was created.
-
description: stringThe description of the assistant. The maximum length is 512 characters.
-
instructions: stringThe system instructions that the assistant uses. The maximum length is 256,000 characters.
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
model: stringID of the model to use. You can use the List models API to see all of your available models, or see our Model overview for descriptions of them.
-
name: stringThe name of the assistant. The maximum length is 256 characters.
-
object: "assistant"The object type, which is always
assistant."assistant"
-
tools: array of CodeInterpreterTool or FileSearchTool or FunctionToolA list of tool enabled on the assistant. There can be a maximum of 128 tools per assistant. Tools can be of types
code_interpreter,file_search, orfunction.-
CodeInterpreterTool object { type }-
type: "code_interpreter"The type of tool being defined:
code_interpreter"code_interpreter"
-
-
FileSearchTool object { type, file_search }-
type: "file_search"The type of tool being defined:
file_search"file_search"
-
file_search: optional object { max_num_results, ranking_options }Overrides for the file search tool.
-
max_num_results: optional numberThe maximum number of results the file search tool should output. The default is 20 for
gpt-4*models and 5 forgpt-3.5-turbo. This number should be between 1 and 50 inclusive.Note that the file search tool may output fewer than
max_num_resultsresults. See the file search tool documentation for more information. -
ranking_options: optional object { score_threshold, ranker }The ranking options for the file search. If not specified, the file search tool will use the
autoranker and a score_threshold of 0.See the file search tool documentation for more information.
-
score_threshold: numberThe score threshold for the file search. All values must be a floating point number between 0 and 1.
-
ranker: optional "auto" or "default_2024_08_21"The ranker to use for the file search. If not specified will use the
autoranker.-
"auto" -
"default_2024_08_21"
-
-
-
-
-
FunctionTool object { function, type }-
function: FunctionDefinition-
name: stringThe name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
description: optional stringA description of what the function does, used by the model to choose when and how to call the function.
-
parameters: optional FunctionParametersThe parameters the functions accepts, described as a JSON Schema object. See the guide for examples, and the JSON Schema reference for documentation about the format.
Omitting
parametersdefines a function with an empty parameter list. -
strict: optional booleanWhether to enable strict schema adherence when generating the function call. If set to true, the model will follow the exact schema defined in the
parametersfield. Only a subset of JSON Schema is supported whenstrictistrue. Learn more about Structured Outputs in the function calling guide.
-
-
type: "function"The type of tool being defined:
function"function"
-
-
-
response_format: optional AssistantResponseFormatOptionSpecifies the format that the model must output. Compatible with GPT-4o, GPT-4 Turbo, and all GPT-3.5 Turbo models since
gpt-3.5-turbo-1106.Setting to
{ "type": "json_schema", "json_schema": {...} }enables Structured Outputs which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide.Setting to
{ "type": "json_object" }enables JSON mode, which ensures the message the model generates is valid JSON.Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly "stuck" request. Also note that the message content may be partially cut off if
finish_reason="length", which indicates the generation exceededmax_tokensor the conversation exceeded the max context length.-
"auto"autois the default value"auto"
-
ResponseFormatText object { type }Default response format. Used to generate text responses.
-
type: "text"The type of response format being defined. Always
text."text"
-
-
ResponseFormatJSONObject object { type }JSON object response format. An older method of generating JSON responses. Using
json_schemais recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.-
type: "json_object"The type of response format being defined. Always
json_object."json_object"
-
-
ResponseFormatJSONSchema object { json_schema, type }JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.
-
json_schema: object { name, description, schema, strict }Structured Outputs configuration options, including a JSON Schema.
-
name: stringThe name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
description: optional stringA description of what the response format is for, used by the model to determine how to respond in the format.
-
schema: optional map[unknown]The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
-
strict: optional booleanWhether to enable strict schema adherence when generating the output. If set to true, the model will always follow the exact schema defined in the
schemafield. Only a subset of JSON Schema is supported whenstrictistrue. To learn more, read the Structured Outputs guide.
-
-
type: "json_schema"The type of response format being defined. Always
json_schema."json_schema"
-
-
-
temperature: optional numberWhat sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic.
-
tool_resources: optional object { code_interpreter, file_search }A set of resources that are used by the assistant's tools. The resources are specific to the type of tool. For example, the
code_interpretertool requires a list of file IDs, while thefile_searchtool requires a list of vector store IDs.-
code_interpreter: optional object { file_ids }-
file_ids: optional array of stringA list of file IDs made available to the `code_interpreter`` tool. There can be a maximum of 20 files associated with the tool.
-
-
file_search: optional object { vector_store_ids }-
vector_store_ids: optional array of stringThe ID of the vector store attached to this assistant. There can be a maximum of 1 vector store attached to the assistant.
-
-
-
top_p: optional numberAn alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.
We generally recommend altering this or temperature but not both.
-
-
first_id: string -
has_more: boolean -
last_id: string -
object: string
Example
curl https://api.openai.com/v1/assistants \
-H 'OpenAI-Beta: assistants=v2' \
-H "Authorization: Bearer $OPENAI_API_KEY"
Response
{
"data": [
{
"id": "id",
"created_at": 0,
"description": "description",
"instructions": "instructions",
"metadata": {
"foo": "string"
},
"model": "model",
"name": "name",
"object": "assistant",
"tools": [
{
"type": "code_interpreter"
}
],
"response_format": "auto",
"temperature": 1,
"tool_resources": {
"code_interpreter": {
"file_ids": [
"string"
]
},
"file_search": {
"vector_store_ids": [
"string"
]
}
},
"top_p": 1
}
],
"first_id": "asst_abc123",
"has_more": false,
"last_id": "asst_abc456",
"object": "list"
}
Example
curl "https://api.openai.com/v1/assistants?order=desc&limit=20" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer $OPENAI_API_KEY" \
-H "OpenAI-Beta: assistants=v2"
Response
{
"object": "list",
"data": [
{
"id": "asst_abc123",
"object": "assistant",
"created_at": 1698982736,
"name": "Coding Tutor",
"description": null,
"model": "gpt-4o",
"instructions": "You are a helpful assistant designed to make me better at coding!",
"tools": [],
"tool_resources": {},
"metadata": {},
"top_p": 1.0,
"temperature": 1.0,
"response_format": "auto"
},
{
"id": "asst_abc456",
"object": "assistant",
"created_at": 1698982718,
"name": "My Assistant",
"description": null,
"model": "gpt-4o",
"instructions": "You are a helpful assistant designed to make me better at coding!",
"tools": [],
"tool_resources": {},
"metadata": {},
"top_p": 1.0,
"temperature": 1.0,
"response_format": "auto"
},
{
"id": "asst_abc789",
"object": "assistant",
"created_at": 1698982643,
"name": null,
"description": null,
"model": "gpt-4o",
"instructions": null,
"tools": [],
"tool_resources": {},
"metadata": {},
"top_p": 1.0,
"temperature": 1.0,
"response_format": "auto"
}
],
"first_id": "asst_abc123",
"last_id": "asst_abc789",
"has_more": false
}
Create assistant
post /assistants
Create an assistant with a model and instructions.
Body Parameters
-
model: string or "gpt-5" or "gpt-5-mini" or "gpt-5-nano" or 39 moreID of the model to use. You can use the List models API to see all of your available models, or see our Model overview for descriptions of them.
-
string -
AssistantSupportedModels = "gpt-5" or "gpt-5-mini" or "gpt-5-nano" or 39 moreID of the model to use. You can use the List models API to see all of your available models, or see our Model overview for descriptions of them.
-
"gpt-5" -
"gpt-5-mini" -
"gpt-5-nano" -
"gpt-5-2025-08-07" -
"gpt-5-mini-2025-08-07" -
"gpt-5-nano-2025-08-07" -
"gpt-4.1" -
"gpt-4.1-mini" -
"gpt-4.1-nano" -
"gpt-4.1-2025-04-14" -
"gpt-4.1-mini-2025-04-14" -
"gpt-4.1-nano-2025-04-14" -
"o3-mini" -
"o3-mini-2025-01-31" -
"o1" -
"o1-2024-12-17" -
"gpt-4o" -
"gpt-4o-2024-11-20" -
"gpt-4o-2024-08-06" -
"gpt-4o-2024-05-13" -
"gpt-4o-mini" -
"gpt-4o-mini-2024-07-18" -
"gpt-4.5-preview" -
"gpt-4.5-preview-2025-02-27" -
"gpt-4-turbo" -
"gpt-4-turbo-2024-04-09" -
"gpt-4-0125-preview" -
"gpt-4-turbo-preview" -
"gpt-4-1106-preview" -
"gpt-4-vision-preview" -
"gpt-4" -
"gpt-4-0314" -
"gpt-4-0613" -
"gpt-4-32k" -
"gpt-4-32k-0314" -
"gpt-4-32k-0613" -
"gpt-3.5-turbo" -
"gpt-3.5-turbo-16k" -
"gpt-3.5-turbo-0613" -
"gpt-3.5-turbo-1106" -
"gpt-3.5-turbo-0125" -
"gpt-3.5-turbo-16k-0613"
-
-
-
description: optional stringThe description of the assistant. The maximum length is 512 characters.
-
instructions: optional stringThe system instructions that the assistant uses. The maximum length is 256,000 characters.
-
metadata: optional MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
name: optional stringThe name of the assistant. The maximum length is 256 characters.
-
reasoning_effort: optional ReasoningEffortConstrains effort on reasoning for reasoning models. Currently supported values are
none,minimal,low,medium,high,xhigh, andmax. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response. Not all reasoning models support every value. See the reasoning guide for model-specific support.-
"none" -
"minimal" -
"low" -
"medium" -
"high" -
"xhigh" -
"max"
-
-
response_format: optional AssistantResponseFormatOptionSpecifies the format that the model must output. Compatible with GPT-4o, GPT-4 Turbo, and all GPT-3.5 Turbo models since
gpt-3.5-turbo-1106.Setting to
{ "type": "json_schema", "json_schema": {...} }enables Structured Outputs which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide.Setting to
{ "type": "json_object" }enables JSON mode, which ensures the message the model generates is valid JSON.Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly "stuck" request. Also note that the message content may be partially cut off if
finish_reason="length", which indicates the generation exceededmax_tokensor the conversation exceeded the max context length.-
"auto"autois the default value"auto"
-
ResponseFormatText object { type }Default response format. Used to generate text responses.
-
type: "text"The type of response format being defined. Always
text."text"
-
-
ResponseFormatJSONObject object { type }JSON object response format. An older method of generating JSON responses. Using
json_schemais recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.-
type: "json_object"The type of response format being defined. Always
json_object."json_object"
-
-
ResponseFormatJSONSchema object { json_schema, type }JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.
-
json_schema: object { name, description, schema, strict }Structured Outputs configuration options, including a JSON Schema.
-
name: stringThe name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
description: optional stringA description of what the response format is for, used by the model to determine how to respond in the format.
-
schema: optional map[unknown]The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
-
strict: optional booleanWhether to enable strict schema adherence when generating the output. If set to true, the model will always follow the exact schema defined in the
schemafield. Only a subset of JSON Schema is supported whenstrictistrue. To learn more, read the Structured Outputs guide.
-
-
type: "json_schema"The type of response format being defined. Always
json_schema."json_schema"
-
-
-
temperature: optional numberWhat sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic.
-
tool_resources: optional object { code_interpreter, file_search }A set of resources that are used by the assistant's tools. The resources are specific to the type of tool. For example, the
code_interpretertool requires a list of file IDs, while thefile_searchtool requires a list of vector store IDs.-
code_interpreter: optional object { file_ids }-
file_ids: optional array of stringA list of file IDs made available to the
code_interpretertool. There can be a maximum of 20 files associated with the tool.
-
-
file_search: optional object { vector_store_ids, vector_stores }-
vector_store_ids: optional array of stringThe vector store attached to this assistant. There can be a maximum of 1 vector store attached to the assistant.
-
vector_stores: optional array of object { chunking_strategy, file_ids, metadata }A helper to create a vector store with file_ids and attach it to this assistant. There can be a maximum of 1 vector store attached to the assistant.
-
chunking_strategy: optional object { type } or object { static, type }The chunking strategy used to chunk the file(s). If not set, will use the
autostrategy.-
AutoChunkingStrategy object { type }The default strategy. This strategy currently uses a
max_chunk_size_tokensof800andchunk_overlap_tokensof400.-
type: "auto"Always
auto."auto"
-
-
StaticChunkingStrategy object { static, type }-
static: object { chunk_overlap_tokens, max_chunk_size_tokens }-
chunk_overlap_tokens: numberThe number of tokens that overlap between chunks. The default value is
400.Note that the overlap must not exceed half of
max_chunk_size_tokens. -
max_chunk_size_tokens: numberThe maximum number of tokens in each chunk. The default value is
800. The minimum value is100and the maximum value is4096.
-
-
type: "static"Always
static."static"
-
-
-
file_ids: optional array of stringA list of file IDs to add to the vector store. For vector stores created before Nov 2025, there can be a maximum of 10,000 files in a vector store. For vector stores created starting in Nov 2025, the limit is 100,000,000 files.
-
metadata: optional MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
-
-
-
tools: optional array of CodeInterpreterTool or FileSearchTool or FunctionToolA list of tool enabled on the assistant. There can be a maximum of 128 tools per assistant. Tools can be of types
code_interpreter,file_search, orfunction.-
CodeInterpreterTool object { type }-
type: "code_interpreter"The type of tool being defined:
code_interpreter"code_interpreter"
-
-
FileSearchTool object { type, file_search }-
type: "file_search"The type of tool being defined:
file_search"file_search"
-
file_search: optional object { max_num_results, ranking_options }Overrides for the file search tool.
-
max_num_results: optional numberThe maximum number of results the file search tool should output. The default is 20 for
gpt-4*models and 5 forgpt-3.5-turbo. This number should be between 1 and 50 inclusive.Note that the file search tool may output fewer than
max_num_resultsresults. See the file search tool documentation for more information. -
ranking_options: optional object { score_threshold, ranker }The ranking options for the file search. If not specified, the file search tool will use the
autoranker and a score_threshold of 0.See the file search tool documentation for more information.
-
score_threshold: numberThe score threshold for the file search. All values must be a floating point number between 0 and 1.
-
ranker: optional "auto" or "default_2024_08_21"The ranker to use for the file search. If not specified will use the
autoranker.-
"auto" -
"default_2024_08_21"
-
-
-
-
-
FunctionTool object { function, type }-
function: FunctionDefinition-
name: stringThe name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
description: optional stringA description of what the function does, used by the model to choose when and how to call the function.
-
parameters: optional FunctionParametersThe parameters the functions accepts, described as a JSON Schema object. See the guide for examples, and the JSON Schema reference for documentation about the format.
Omitting
parametersdefines a function with an empty parameter list. -
strict: optional booleanWhether to enable strict schema adherence when generating the function call. If set to true, the model will follow the exact schema defined in the
parametersfield. Only a subset of JSON Schema is supported whenstrictistrue. Learn more about Structured Outputs in the function calling guide.
-
-
type: "function"The type of tool being defined:
function"function"
-
-
-
top_p: optional numberAn alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.
We generally recommend altering this or temperature but not both.
Returns
-
Assistant object { id, created_at, description, 10 more }Represents an
assistantthat can call the model and use tools.-
id: stringThe identifier, which can be referenced in API endpoints.
-
created_at: numberThe Unix timestamp (in seconds) for when the assistant was created.
-
description: stringThe description of the assistant. The maximum length is 512 characters.
-
instructions: stringThe system instructions that the assistant uses. The maximum length is 256,000 characters.
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
model: stringID of the model to use. You can use the List models API to see all of your available models, or see our Model overview for descriptions of them.
-
name: stringThe name of the assistant. The maximum length is 256 characters.
-
object: "assistant"The object type, which is always
assistant."assistant"
-
tools: array of CodeInterpreterTool or FileSearchTool or FunctionToolA list of tool enabled on the assistant. There can be a maximum of 128 tools per assistant. Tools can be of types
code_interpreter,file_search, orfunction.-
CodeInterpreterTool object { type }-
type: "code_interpreter"The type of tool being defined:
code_interpreter"code_interpreter"
-
-
FileSearchTool object { type, file_search }-
type: "file_search"The type of tool being defined:
file_search"file_search"
-
file_search: optional object { max_num_results, ranking_options }Overrides for the file search tool.
-
max_num_results: optional numberThe maximum number of results the file search tool should output. The default is 20 for
gpt-4*models and 5 forgpt-3.5-turbo. This number should be between 1 and 50 inclusive.Note that the file search tool may output fewer than
max_num_resultsresults. See the file search tool documentation for more information. -
ranking_options: optional object { score_threshold, ranker }The ranking options for the file search. If not specified, the file search tool will use the
autoranker and a score_threshold of 0.See the file search tool documentation for more information.
-
score_threshold: numberThe score threshold for the file search. All values must be a floating point number between 0 and 1.
-
ranker: optional "auto" or "default_2024_08_21"The ranker to use for the file search. If not specified will use the
autoranker.-
"auto" -
"default_2024_08_21"
-
-
-
-
-
FunctionTool object { function, type }-
function: FunctionDefinition-
name: stringThe name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
description: optional stringA description of what the function does, used by the model to choose when and how to call the function.
-
parameters: optional FunctionParametersThe parameters the functions accepts, described as a JSON Schema object. See the guide for examples, and the JSON Schema reference for documentation about the format.
Omitting
parametersdefines a function with an empty parameter list. -
strict: optional booleanWhether to enable strict schema adherence when generating the function call. If set to true, the model will follow the exact schema defined in the
parametersfield. Only a subset of JSON Schema is supported whenstrictistrue. Learn more about Structured Outputs in the function calling guide.
-
-
type: "function"The type of tool being defined:
function"function"
-
-
-
response_format: optional AssistantResponseFormatOptionSpecifies the format that the model must output. Compatible with GPT-4o, GPT-4 Turbo, and all GPT-3.5 Turbo models since
gpt-3.5-turbo-1106.Setting to
{ "type": "json_schema", "json_schema": {...} }enables Structured Outputs which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide.Setting to
{ "type": "json_object" }enables JSON mode, which ensures the message the model generates is valid JSON.Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly "stuck" request. Also note that the message content may be partially cut off if
finish_reason="length", which indicates the generation exceededmax_tokensor the conversation exceeded the max context length.-
"auto"autois the default value"auto"
-
ResponseFormatText object { type }Default response format. Used to generate text responses.
-
type: "text"The type of response format being defined. Always
text."text"
-
-
ResponseFormatJSONObject object { type }JSON object response format. An older method of generating JSON responses. Using
json_schemais recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.-
type: "json_object"The type of response format being defined. Always
json_object."json_object"
-
-
ResponseFormatJSONSchema object { json_schema, type }JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.
-
json_schema: object { name, description, schema, strict }Structured Outputs configuration options, including a JSON Schema.
-
name: stringThe name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
description: optional stringA description of what the response format is for, used by the model to determine how to respond in the format.
-
schema: optional map[unknown]The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
-
strict: optional booleanWhether to enable strict schema adherence when generating the output. If set to true, the model will always follow the exact schema defined in the
schemafield. Only a subset of JSON Schema is supported whenstrictistrue. To learn more, read the Structured Outputs guide.
-
-
type: "json_schema"The type of response format being defined. Always
json_schema."json_schema"
-
-
-
temperature: optional numberWhat sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic.
-
tool_resources: optional object { code_interpreter, file_search }A set of resources that are used by the assistant's tools. The resources are specific to the type of tool. For example, the
code_interpretertool requires a list of file IDs, while thefile_searchtool requires a list of vector store IDs.-
code_interpreter: optional object { file_ids }-
file_ids: optional array of stringA list of file IDs made available to the `code_interpreter`` tool. There can be a maximum of 20 files associated with the tool.
-
-
file_search: optional object { vector_store_ids }-
vector_store_ids: optional array of stringThe ID of the vector store attached to this assistant. There can be a maximum of 1 vector store attached to the assistant.
-
-
-
top_p: optional numberAn alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.
We generally recommend altering this or temperature but not both.
-
Example
curl https://api.openai.com/v1/assistants \
-H 'Content-Type: application/json' \
-H 'OpenAI-Beta: assistants=v2' \
-H "Authorization: Bearer $OPENAI_API_KEY" \
-d '{
"model": "gpt-4o",
"temperature": 1,
"top_p": 1
}'
Response
{
"id": "id",
"created_at": 0,
"description": "description",
"instructions": "instructions",
"metadata": {
"foo": "string"
},
"model": "model",
"name": "name",
"object": "assistant",
"tools": [
{
"type": "code_interpreter"
}
],
"response_format": "auto",
"temperature": 1,
"tool_resources": {
"code_interpreter": {
"file_ids": [
"string"
]
},
"file_search": {
"vector_store_ids": [
"string"
]
}
},
"top_p": 1
}
Code Interpreter
curl "https://api.openai.com/v1/assistants" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer $OPENAI_API_KEY" \
-H "OpenAI-Beta: assistants=v2" \
-d '{
"instructions": "You are a personal math tutor. When asked a question, write and run Python code to answer the question.",
"name": "Math Tutor",
"tools": [{"type": "code_interpreter"}],
"model": "gpt-4o"
}'
Response
{
"id": "asst_abc123",
"object": "assistant",
"created_at": 1698984975,
"name": "Math Tutor",
"description": null,
"model": "gpt-4o",
"instructions": "You are a personal math tutor. When asked a question, write and run Python code to answer the question.",
"tools": [
{
"type": "code_interpreter"
}
],
"metadata": {},
"top_p": 1.0,
"temperature": 1.0,
"response_format": "auto"
}
Files
curl https://api.openai.com/v1/assistants \
-H "Content-Type: application/json" \
-H "Authorization: Bearer $OPENAI_API_KEY" \
-H "OpenAI-Beta: assistants=v2" \
-d '{
"instructions": "You are an HR bot, and you have access to files to answer employee questions about company policies.",
"tools": [{"type": "file_search"}],
"tool_resources": {"file_search": {"vector_store_ids": ["vs_123"]}},
"model": "gpt-4o"
}'
Response
{
"id": "asst_abc123",
"object": "assistant",
"created_at": 1699009403,
"name": "HR Helper",
"description": null,
"model": "gpt-4o",
"instructions": "You are an HR bot, and you have access to files to answer employee questions about company policies.",
"tools": [
{
"type": "file_search"
}
],
"tool_resources": {
"file_search": {
"vector_store_ids": ["vs_123"]
}
},
"metadata": {},
"top_p": 1.0,
"temperature": 1.0,
"response_format": "auto"
}
Retrieve assistant
get /assistants/{assistant_id}
Retrieves an assistant.
Path Parameters
assistant_id: string
Returns
-
Assistant object { id, created_at, description, 10 more }Represents an
assistantthat can call the model and use tools.-
id: stringThe identifier, which can be referenced in API endpoints.
-
created_at: numberThe Unix timestamp (in seconds) for when the assistant was created.
-
description: stringThe description of the assistant. The maximum length is 512 characters.
-
instructions: stringThe system instructions that the assistant uses. The maximum length is 256,000 characters.
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
model: stringID of the model to use. You can use the List models API to see all of your available models, or see our Model overview for descriptions of them.
-
name: stringThe name of the assistant. The maximum length is 256 characters.
-
object: "assistant"The object type, which is always
assistant."assistant"
-
tools: array of CodeInterpreterTool or FileSearchTool or FunctionToolA list of tool enabled on the assistant. There can be a maximum of 128 tools per assistant. Tools can be of types
code_interpreter,file_search, orfunction.-
CodeInterpreterTool object { type }-
type: "code_interpreter"The type of tool being defined:
code_interpreter"code_interpreter"
-
-
FileSearchTool object { type, file_search }-
type: "file_search"The type of tool being defined:
file_search"file_search"
-
file_search: optional object { max_num_results, ranking_options }Overrides for the file search tool.
-
max_num_results: optional numberThe maximum number of results the file search tool should output. The default is 20 for
gpt-4*models and 5 forgpt-3.5-turbo. This number should be between 1 and 50 inclusive.Note that the file search tool may output fewer than
max_num_resultsresults. See the file search tool documentation for more information. -
ranking_options: optional object { score_threshold, ranker }The ranking options for the file search. If not specified, the file search tool will use the
autoranker and a score_threshold of 0.See the file search tool documentation for more information.
-
score_threshold: numberThe score threshold for the file search. All values must be a floating point number between 0 and 1.
-
ranker: optional "auto" or "default_2024_08_21"The ranker to use for the file search. If not specified will use the
autoranker.-
"auto" -
"default_2024_08_21"
-
-
-
-
-
FunctionTool object { function, type }-
function: FunctionDefinition-
name: stringThe name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
description: optional stringA description of what the function does, used by the model to choose when and how to call the function.
-
parameters: optional FunctionParametersThe parameters the functions accepts, described as a JSON Schema object. See the guide for examples, and the JSON Schema reference for documentation about the format.
Omitting
parametersdefines a function with an empty parameter list. -
strict: optional booleanWhether to enable strict schema adherence when generating the function call. If set to true, the model will follow the exact schema defined in the
parametersfield. Only a subset of JSON Schema is supported whenstrictistrue. Learn more about Structured Outputs in the function calling guide.
-
-
type: "function"The type of tool being defined:
function"function"
-
-
-
response_format: optional AssistantResponseFormatOptionSpecifies the format that the model must output. Compatible with GPT-4o, GPT-4 Turbo, and all GPT-3.5 Turbo models since
gpt-3.5-turbo-1106.Setting to
{ "type": "json_schema", "json_schema": {...} }enables Structured Outputs which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide.Setting to
{ "type": "json_object" }enables JSON mode, which ensures the message the model generates is valid JSON.Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly "stuck" request. Also note that the message content may be partially cut off if
finish_reason="length", which indicates the generation exceededmax_tokensor the conversation exceeded the max context length.-
"auto"autois the default value"auto"
-
ResponseFormatText object { type }Default response format. Used to generate text responses.
-
type: "text"The type of response format being defined. Always
text."text"
-
-
ResponseFormatJSONObject object { type }JSON object response format. An older method of generating JSON responses. Using
json_schemais recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.-
type: "json_object"The type of response format being defined. Always
json_object."json_object"
-
-
ResponseFormatJSONSchema object { json_schema, type }JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.
-
json_schema: object { name, description, schema, strict }Structured Outputs configuration options, including a JSON Schema.
-
name: stringThe name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
description: optional stringA description of what the response format is for, used by the model to determine how to respond in the format.
-
schema: optional map[unknown]The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
-
strict: optional booleanWhether to enable strict schema adherence when generating the output. If set to true, the model will always follow the exact schema defined in the
schemafield. Only a subset of JSON Schema is supported whenstrictistrue. To learn more, read the Structured Outputs guide.
-
-
type: "json_schema"The type of response format being defined. Always
json_schema."json_schema"
-
-
-
temperature: optional numberWhat sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic.
-
tool_resources: optional object { code_interpreter, file_search }A set of resources that are used by the assistant's tools. The resources are specific to the type of tool. For example, the
code_interpretertool requires a list of file IDs, while thefile_searchtool requires a list of vector store IDs.-
code_interpreter: optional object { file_ids }-
file_ids: optional array of stringA list of file IDs made available to the `code_interpreter`` tool. There can be a maximum of 20 files associated with the tool.
-
-
file_search: optional object { vector_store_ids }-
vector_store_ids: optional array of stringThe ID of the vector store attached to this assistant. There can be a maximum of 1 vector store attached to the assistant.
-
-
-
top_p: optional numberAn alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.
We generally recommend altering this or temperature but not both.
-
Example
curl https://api.openai.com/v1/assistants/$ASSISTANT_ID \
-H 'OpenAI-Beta: assistants=v2' \
-H "Authorization: Bearer $OPENAI_API_KEY"
Response
{
"id": "id",
"created_at": 0,
"description": "description",
"instructions": "instructions",
"metadata": {
"foo": "string"
},
"model": "model",
"name": "name",
"object": "assistant",
"tools": [
{
"type": "code_interpreter"
}
],
"response_format": "auto",
"temperature": 1,
"tool_resources": {
"code_interpreter": {
"file_ids": [
"string"
]
},
"file_search": {
"vector_store_ids": [
"string"
]
}
},
"top_p": 1
}
Example
curl https://api.openai.com/v1/assistants/asst_abc123 \
-H "Content-Type: application/json" \
-H "Authorization: Bearer $OPENAI_API_KEY" \
-H "OpenAI-Beta: assistants=v2"
Response
{
"id": "asst_abc123",
"object": "assistant",
"created_at": 1699009709,
"name": "HR Helper",
"description": null,
"model": "gpt-4o",
"instructions": "You are an HR bot, and you have access to files to answer employee questions about company policies.",
"tools": [
{
"type": "file_search"
}
],
"metadata": {},
"top_p": 1.0,
"temperature": 1.0,
"response_format": "auto"
}
Modify assistant
post /assistants/{assistant_id}
Modifies an assistant.
Path Parameters
assistant_id: string
Body Parameters
-
description: optional stringThe description of the assistant. The maximum length is 512 characters.
-
instructions: optional stringThe system instructions that the assistant uses. The maximum length is 256,000 characters.
-
metadata: optional MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
model: optional string or "gpt-5" or "gpt-5-mini" or "gpt-5-nano" or 39 moreID of the model to use. You can use the List models API to see all of your available models, or see our Model overview for descriptions of them.
-
string -
AssistantSupportedModels = "gpt-5" or "gpt-5-mini" or "gpt-5-nano" or 39 moreID of the model to use. You can use the List models API to see all of your available models, or see our Model overview for descriptions of them.
-
"gpt-5" -
"gpt-5-mini" -
"gpt-5-nano" -
"gpt-5-2025-08-07" -
"gpt-5-mini-2025-08-07" -
"gpt-5-nano-2025-08-07" -
"gpt-4.1" -
"gpt-4.1-mini" -
"gpt-4.1-nano" -
"gpt-4.1-2025-04-14" -
"gpt-4.1-mini-2025-04-14" -
"gpt-4.1-nano-2025-04-14" -
"o3-mini" -
"o3-mini-2025-01-31" -
"o1" -
"o1-2024-12-17" -
"gpt-4o" -
"gpt-4o-2024-11-20" -
"gpt-4o-2024-08-06" -
"gpt-4o-2024-05-13" -
"gpt-4o-mini" -
"gpt-4o-mini-2024-07-18" -
"gpt-4.5-preview" -
"gpt-4.5-preview-2025-02-27" -
"gpt-4-turbo" -
"gpt-4-turbo-2024-04-09" -
"gpt-4-0125-preview" -
"gpt-4-turbo-preview" -
"gpt-4-1106-preview" -
"gpt-4-vision-preview" -
"gpt-4" -
"gpt-4-0314" -
"gpt-4-0613" -
"gpt-4-32k" -
"gpt-4-32k-0314" -
"gpt-4-32k-0613" -
"gpt-3.5-turbo" -
"gpt-3.5-turbo-16k" -
"gpt-3.5-turbo-0613" -
"gpt-3.5-turbo-1106" -
"gpt-3.5-turbo-0125" -
"gpt-3.5-turbo-16k-0613"
-
-
-
name: optional stringThe name of the assistant. The maximum length is 256 characters.
-
reasoning_effort: optional ReasoningEffortConstrains effort on reasoning for reasoning models. Currently supported values are
none,minimal,low,medium,high,xhigh, andmax. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response. Not all reasoning models support every value. See the reasoning guide for model-specific support.-
"none" -
"minimal" -
"low" -
"medium" -
"high" -
"xhigh" -
"max"
-
-
response_format: optional AssistantResponseFormatOptionSpecifies the format that the model must output. Compatible with GPT-4o, GPT-4 Turbo, and all GPT-3.5 Turbo models since
gpt-3.5-turbo-1106.Setting to
{ "type": "json_schema", "json_schema": {...} }enables Structured Outputs which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide.Setting to
{ "type": "json_object" }enables JSON mode, which ensures the message the model generates is valid JSON.Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly "stuck" request. Also note that the message content may be partially cut off if
finish_reason="length", which indicates the generation exceededmax_tokensor the conversation exceeded the max context length.-
"auto"autois the default value"auto"
-
ResponseFormatText object { type }Default response format. Used to generate text responses.
-
type: "text"The type of response format being defined. Always
text."text"
-
-
ResponseFormatJSONObject object { type }JSON object response format. An older method of generating JSON responses. Using
json_schemais recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.-
type: "json_object"The type of response format being defined. Always
json_object."json_object"
-
-
ResponseFormatJSONSchema object { json_schema, type }JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.
-
json_schema: object { name, description, schema, strict }Structured Outputs configuration options, including a JSON Schema.
-
name: stringThe name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
description: optional stringA description of what the response format is for, used by the model to determine how to respond in the format.
-
schema: optional map[unknown]The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
-
strict: optional booleanWhether to enable strict schema adherence when generating the output. If set to true, the model will always follow the exact schema defined in the
schemafield. Only a subset of JSON Schema is supported whenstrictistrue. To learn more, read the Structured Outputs guide.
-
-
type: "json_schema"The type of response format being defined. Always
json_schema."json_schema"
-
-
-
temperature: optional numberWhat sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic.
-
tool_resources: optional object { code_interpreter, file_search }A set of resources that are used by the assistant's tools. The resources are specific to the type of tool. For example, the
code_interpretertool requires a list of file IDs, while thefile_searchtool requires a list of vector store IDs.-
code_interpreter: optional object { file_ids }-
file_ids: optional array of stringOverrides the list of file IDs made available to the
code_interpretertool. There can be a maximum of 20 files associated with the tool.
-
-
file_search: optional object { vector_store_ids }-
vector_store_ids: optional array of stringOverrides the vector store attached to this assistant. There can be a maximum of 1 vector store attached to the assistant.
-
-
-
tools: optional array of CodeInterpreterTool or FileSearchTool or FunctionToolA list of tool enabled on the assistant. There can be a maximum of 128 tools per assistant. Tools can be of types
code_interpreter,file_search, orfunction.-
CodeInterpreterTool object { type }-
type: "code_interpreter"The type of tool being defined:
code_interpreter"code_interpreter"
-
-
FileSearchTool object { type, file_search }-
type: "file_search"The type of tool being defined:
file_search"file_search"
-
file_search: optional object { max_num_results, ranking_options }Overrides for the file search tool.
-
max_num_results: optional numberThe maximum number of results the file search tool should output. The default is 20 for
gpt-4*models and 5 forgpt-3.5-turbo. This number should be between 1 and 50 inclusive.Note that the file search tool may output fewer than
max_num_resultsresults. See the file search tool documentation for more information. -
ranking_options: optional object { score_threshold, ranker }The ranking options for the file search. If not specified, the file search tool will use the
autoranker and a score_threshold of 0.See the file search tool documentation for more information.
-
score_threshold: numberThe score threshold for the file search. All values must be a floating point number between 0 and 1.
-
ranker: optional "auto" or "default_2024_08_21"The ranker to use for the file search. If not specified will use the
autoranker.-
"auto" -
"default_2024_08_21"
-
-
-
-
-
FunctionTool object { function, type }-
function: FunctionDefinition-
name: stringThe name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
description: optional stringA description of what the function does, used by the model to choose when and how to call the function.
-
parameters: optional FunctionParametersThe parameters the functions accepts, described as a JSON Schema object. See the guide for examples, and the JSON Schema reference for documentation about the format.
Omitting
parametersdefines a function with an empty parameter list. -
strict: optional booleanWhether to enable strict schema adherence when generating the function call. If set to true, the model will follow the exact schema defined in the
parametersfield. Only a subset of JSON Schema is supported whenstrictistrue. Learn more about Structured Outputs in the function calling guide.
-
-
type: "function"The type of tool being defined:
function"function"
-
-
-
top_p: optional numberAn alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.
We generally recommend altering this or temperature but not both.
Returns
-
Assistant object { id, created_at, description, 10 more }Represents an
assistantthat can call the model and use tools.-
id: stringThe identifier, which can be referenced in API endpoints.
-
created_at: numberThe Unix timestamp (in seconds) for when the assistant was created.
-
description: stringThe description of the assistant. The maximum length is 512 characters.
-
instructions: stringThe system instructions that the assistant uses. The maximum length is 256,000 characters.
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
model: stringID of the model to use. You can use the List models API to see all of your available models, or see our Model overview for descriptions of them.
-
name: stringThe name of the assistant. The maximum length is 256 characters.
-
object: "assistant"The object type, which is always
assistant."assistant"
-
tools: array of CodeInterpreterTool or FileSearchTool or FunctionToolA list of tool enabled on the assistant. There can be a maximum of 128 tools per assistant. Tools can be of types
code_interpreter,file_search, orfunction.-
CodeInterpreterTool object { type }-
type: "code_interpreter"The type of tool being defined:
code_interpreter"code_interpreter"
-
-
FileSearchTool object { type, file_search }-
type: "file_search"The type of tool being defined:
file_search"file_search"
-
file_search: optional object { max_num_results, ranking_options }Overrides for the file search tool.
-
max_num_results: optional numberThe maximum number of results the file search tool should output. The default is 20 for
gpt-4*models and 5 forgpt-3.5-turbo. This number should be between 1 and 50 inclusive.Note that the file search tool may output fewer than
max_num_resultsresults. See the file search tool documentation for more information. -
ranking_options: optional object { score_threshold, ranker }The ranking options for the file search. If not specified, the file search tool will use the
autoranker and a score_threshold of 0.See the file search tool documentation for more information.
-
score_threshold: numberThe score threshold for the file search. All values must be a floating point number between 0 and 1.
-
ranker: optional "auto" or "default_2024_08_21"The ranker to use for the file search. If not specified will use the
autoranker.-
"auto" -
"default_2024_08_21"
-
-
-
-
-
FunctionTool object { function, type }-
function: FunctionDefinition-
name: stringThe name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
description: optional stringA description of what the function does, used by the model to choose when and how to call the function.
-
parameters: optional FunctionParametersThe parameters the functions accepts, described as a JSON Schema object. See the guide for examples, and the JSON Schema reference for documentation about the format.
Omitting
parametersdefines a function with an empty parameter list. -
strict: optional booleanWhether to enable strict schema adherence when generating the function call. If set to true, the model will follow the exact schema defined in the
parametersfield. Only a subset of JSON Schema is supported whenstrictistrue. Learn more about Structured Outputs in the function calling guide.
-
-
type: "function"The type of tool being defined:
function"function"
-
-
-
response_format: optional AssistantResponseFormatOptionSpecifies the format that the model must output. Compatible with GPT-4o, GPT-4 Turbo, and all GPT-3.5 Turbo models since
gpt-3.5-turbo-1106.Setting to
{ "type": "json_schema", "json_schema": {...} }enables Structured Outputs which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide.Setting to
{ "type": "json_object" }enables JSON mode, which ensures the message the model generates is valid JSON.Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly "stuck" request. Also note that the message content may be partially cut off if
finish_reason="length", which indicates the generation exceededmax_tokensor the conversation exceeded the max context length.-
"auto"autois the default value"auto"
-
ResponseFormatText object { type }Default response format. Used to generate text responses.
-
type: "text"The type of response format being defined. Always
text."text"
-
-
ResponseFormatJSONObject object { type }JSON object response format. An older method of generating JSON responses. Using
json_schemais recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.-
type: "json_object"The type of response format being defined. Always
json_object."json_object"
-
-
ResponseFormatJSONSchema object { json_schema, type }JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.
-
json_schema: object { name, description, schema, strict }Structured Outputs configuration options, including a JSON Schema.
-
name: stringThe name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
description: optional stringA description of what the response format is for, used by the model to determine how to respond in the format.
-
schema: optional map[unknown]The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
-
strict: optional booleanWhether to enable strict schema adherence when generating the output. If set to true, the model will always follow the exact schema defined in the
schemafield. Only a subset of JSON Schema is supported whenstrictistrue. To learn more, read the Structured Outputs guide.
-
-
type: "json_schema"The type of response format being defined. Always
json_schema."json_schema"
-
-
-
temperature: optional numberWhat sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic.
-
tool_resources: optional object { code_interpreter, file_search }A set of resources that are used by the assistant's tools. The resources are specific to the type of tool. For example, the
code_interpretertool requires a list of file IDs, while thefile_searchtool requires a list of vector store IDs.-
code_interpreter: optional object { file_ids }-
file_ids: optional array of stringA list of file IDs made available to the `code_interpreter`` tool. There can be a maximum of 20 files associated with the tool.
-
-
file_search: optional object { vector_store_ids }-
vector_store_ids: optional array of stringThe ID of the vector store attached to this assistant. There can be a maximum of 1 vector store attached to the assistant.
-
-
-
top_p: optional numberAn alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.
We generally recommend altering this or temperature but not both.
-
Example
curl https://api.openai.com/v1/assistants/$ASSISTANT_ID \
-H 'Content-Type: application/json' \
-H 'OpenAI-Beta: assistants=v2' \
-H "Authorization: Bearer $OPENAI_API_KEY" \
-d '{
"temperature": 1,
"top_p": 1
}'
Response
{
"id": "id",
"created_at": 0,
"description": "description",
"instructions": "instructions",
"metadata": {
"foo": "string"
},
"model": "model",
"name": "name",
"object": "assistant",
"tools": [
{
"type": "code_interpreter"
}
],
"response_format": "auto",
"temperature": 1,
"tool_resources": {
"code_interpreter": {
"file_ids": [
"string"
]
},
"file_search": {
"vector_store_ids": [
"string"
]
}
},
"top_p": 1
}
Example
curl https://api.openai.com/v1/assistants/asst_abc123 \
-H "Content-Type: application/json" \
-H "Authorization: Bearer $OPENAI_API_KEY" \
-H "OpenAI-Beta: assistants=v2" \
-d '{
"instructions": "You are an HR bot, and you have access to files to answer employee questions about company policies. Always response with info from either of the files.",
"tools": [{"type": "file_search"}],
"model": "gpt-4o"
}'
Response
{
"id": "asst_123",
"object": "assistant",
"created_at": 1699009709,
"name": "HR Helper",
"description": null,
"model": "gpt-4o",
"instructions": "You are an HR bot, and you have access to files to answer employee questions about company policies. Always response with info from either of the files.",
"tools": [
{
"type": "file_search"
}
],
"tool_resources": {
"file_search": {
"vector_store_ids": []
}
},
"metadata": {},
"top_p": 1.0,
"temperature": 1.0,
"response_format": "auto"
}
Delete assistant
delete /assistants/{assistant_id}
Delete an assistant.
Path Parameters
assistant_id: string
Returns
-
AssistantDeleted object { id, deleted, object }-
id: string -
deleted: boolean -
object: "assistant.deleted""assistant.deleted"
-
Example
curl https://api.openai.com/v1/assistants/$ASSISTANT_ID \
-X DELETE \
-H 'OpenAI-Beta: assistants=v2' \
-H "Authorization: Bearer $OPENAI_API_KEY"
Response
{
"id": "id",
"deleted": true,
"object": "assistant.deleted"
}
Example
curl https://api.openai.com/v1/assistants/asst_abc123 \
-H "Content-Type: application/json" \
-H "Authorization: Bearer $OPENAI_API_KEY" \
-H "OpenAI-Beta: assistants=v2" \
-X DELETE
Response
{
"id": "asst_abc123",
"object": "assistant.deleted",
"deleted": true
}
Domain Types
Assistant
-
Assistant object { id, created_at, description, 10 more }Represents an
assistantthat can call the model and use tools.-
id: stringThe identifier, which can be referenced in API endpoints.
-
created_at: numberThe Unix timestamp (in seconds) for when the assistant was created.
-
description: stringThe description of the assistant. The maximum length is 512 characters.
-
instructions: stringThe system instructions that the assistant uses. The maximum length is 256,000 characters.
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
model: stringID of the model to use. You can use the List models API to see all of your available models, or see our Model overview for descriptions of them.
-
name: stringThe name of the assistant. The maximum length is 256 characters.
-
object: "assistant"The object type, which is always
assistant."assistant"
-
tools: array of CodeInterpreterTool or FileSearchTool or FunctionToolA list of tool enabled on the assistant. There can be a maximum of 128 tools per assistant. Tools can be of types
code_interpreter,file_search, orfunction.-
CodeInterpreterTool object { type }-
type: "code_interpreter"The type of tool being defined:
code_interpreter"code_interpreter"
-
-
FileSearchTool object { type, file_search }-
type: "file_search"The type of tool being defined:
file_search"file_search"
-
file_search: optional object { max_num_results, ranking_options }Overrides for the file search tool.
-
max_num_results: optional numberThe maximum number of results the file search tool should output. The default is 20 for
gpt-4*models and 5 forgpt-3.5-turbo. This number should be between 1 and 50 inclusive.Note that the file search tool may output fewer than
max_num_resultsresults. See the file search tool documentation for more information. -
ranking_options: optional object { score_threshold, ranker }The ranking options for the file search. If not specified, the file search tool will use the
autoranker and a score_threshold of 0.See the file search tool documentation for more information.
-
score_threshold: numberThe score threshold for the file search. All values must be a floating point number between 0 and 1.
-
ranker: optional "auto" or "default_2024_08_21"The ranker to use for the file search. If not specified will use the
autoranker.-
"auto" -
"default_2024_08_21"
-
-
-
-
-
FunctionTool object { function, type }-
function: FunctionDefinition-
name: stringThe name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
description: optional stringA description of what the function does, used by the model to choose when and how to call the function.
-
parameters: optional FunctionParametersThe parameters the functions accepts, described as a JSON Schema object. See the guide for examples, and the JSON Schema reference for documentation about the format.
Omitting
parametersdefines a function with an empty parameter list. -
strict: optional booleanWhether to enable strict schema adherence when generating the function call. If set to true, the model will follow the exact schema defined in the
parametersfield. Only a subset of JSON Schema is supported whenstrictistrue. Learn more about Structured Outputs in the function calling guide.
-
-
type: "function"The type of tool being defined:
function"function"
-
-
-
response_format: optional AssistantResponseFormatOptionSpecifies the format that the model must output. Compatible with GPT-4o, GPT-4 Turbo, and all GPT-3.5 Turbo models since
gpt-3.5-turbo-1106.Setting to
{ "type": "json_schema", "json_schema": {...} }enables Structured Outputs which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide.Setting to
{ "type": "json_object" }enables JSON mode, which ensures the message the model generates is valid JSON.Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly "stuck" request. Also note that the message content may be partially cut off if
finish_reason="length", which indicates the generation exceededmax_tokensor the conversation exceeded the max context length.-
"auto"autois the default value"auto"
-
ResponseFormatText object { type }Default response format. Used to generate text responses.
-
type: "text"The type of response format being defined. Always
text."text"
-
-
ResponseFormatJSONObject object { type }JSON object response format. An older method of generating JSON responses. Using
json_schemais recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.-
type: "json_object"The type of response format being defined. Always
json_object."json_object"
-
-
ResponseFormatJSONSchema object { json_schema, type }JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.
-
json_schema: object { name, description, schema, strict }Structured Outputs configuration options, including a JSON Schema.
-
name: stringThe name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
description: optional stringA description of what the response format is for, used by the model to determine how to respond in the format.
-
schema: optional map[unknown]The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
-
strict: optional booleanWhether to enable strict schema adherence when generating the output. If set to true, the model will always follow the exact schema defined in the
schemafield. Only a subset of JSON Schema is supported whenstrictistrue. To learn more, read the Structured Outputs guide.
-
-
type: "json_schema"The type of response format being defined. Always
json_schema."json_schema"
-
-
-
temperature: optional numberWhat sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic.
-
tool_resources: optional object { code_interpreter, file_search }A set of resources that are used by the assistant's tools. The resources are specific to the type of tool. For example, the
code_interpretertool requires a list of file IDs, while thefile_searchtool requires a list of vector store IDs.-
code_interpreter: optional object { file_ids }-
file_ids: optional array of stringA list of file IDs made available to the `code_interpreter`` tool. There can be a maximum of 20 files associated with the tool.
-
-
file_search: optional object { vector_store_ids }-
vector_store_ids: optional array of stringThe ID of the vector store attached to this assistant. There can be a maximum of 1 vector store attached to the assistant.
-
-
-
top_p: optional numberAn alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.
We generally recommend altering this or temperature but not both.
-
Assistant Deleted
-
AssistantDeleted object { id, deleted, object }-
id: string -
deleted: boolean -
object: "assistant.deleted""assistant.deleted"
-
Assistant Stream Event
-
AssistantStreamEvent = object { data, event, enabled } or object { data, event } or object { data, event } or 22 moreRepresents an event emitted when streaming a Run.
Each event in a server-sent events stream has an
eventanddataproperty:event: thread.created data: {"id": "thread_123", "object": "thread", ...}We emit events whenever a new object is created, transitions to a new state, or is being streamed in parts (deltas). For example, we emit
thread.run.createdwhen a new run is created,thread.run.completedwhen a run completes, and so on. When an Assistant chooses to create a message during a run, we emit athread.message.created event, athread.message.in_progressevent, manythread.message.deltaevents, and finally athread.message.completedevent.We may add additional events over time, so we recommend handling unknown events gracefully in your code. See the Assistants API quickstart to learn how to integrate the Assistants API with streaming.
-
object { data, event, enabled }Occurs when a new thread is created.
-
data: ThreadRepresents a thread that contains messages.
-
id: stringThe identifier, which can be referenced in API endpoints.
-
created_at: numberThe Unix timestamp (in seconds) for when the thread was created.
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
object: "thread"The object type, which is always
thread."thread"
-
tool_resources: object { code_interpreter, file_search }A set of resources that are made available to the assistant's tools in this thread. The resources are specific to the type of tool. For example, the
code_interpretertool requires a list of file IDs, while thefile_searchtool requires a list of vector store IDs.-
code_interpreter: optional object { file_ids }-
file_ids: optional array of stringA list of file IDs made available to the
code_interpretertool. There can be a maximum of 20 files associated with the tool.
-
-
file_search: optional object { vector_store_ids }-
vector_store_ids: optional array of stringThe vector store attached to this thread. There can be a maximum of 1 vector store attached to the thread.
-
-
-
-
event: "thread.created""thread.created"
-
enabled: optional booleanWhether to enable input audio transcription.
-
-
object { data, event }Occurs when a new run is created.
-
data: RunRepresents an execution run on a thread.
-
id: stringThe identifier, which can be referenced in API endpoints.
-
assistant_id: stringThe ID of the assistant used for execution of this run.
-
cancelled_at: numberThe Unix timestamp (in seconds) for when the run was cancelled.
-
completed_at: numberThe Unix timestamp (in seconds) for when the run was completed.
-
created_at: numberThe Unix timestamp (in seconds) for when the run was created.
-
expires_at: numberThe Unix timestamp (in seconds) for when the run will expire.
-
failed_at: numberThe Unix timestamp (in seconds) for when the run failed.
-
incomplete_details: object { reason }Details on why the run is incomplete. Will be
nullif the run is not incomplete.-
reason: optional "max_completion_tokens" or "max_prompt_tokens"The reason why the run is incomplete. This will point to which specific token limit was reached over the course of the run.
-
"max_completion_tokens" -
"max_prompt_tokens"
-
-
-
instructions: stringThe instructions that the assistant used for this run.
-
last_error: object { code, message }The last error associated with this run. Will be
nullif there are no errors.-
code: "server_error" or "rate_limit_exceeded" or "invalid_prompt"One of
server_error,rate_limit_exceeded, orinvalid_prompt.-
"server_error" -
"rate_limit_exceeded" -
"invalid_prompt"
-
-
message: stringA human-readable description of the error.
-
-
max_completion_tokens: numberThe maximum number of completion tokens specified to have been used over the course of the run.
-
max_prompt_tokens: numberThe maximum number of prompt tokens specified to have been used over the course of the run.
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
model: stringThe model that the assistant used for this run.
-
object: "thread.run"The object type, which is always
thread.run."thread.run"
-
parallel_tool_calls: booleanWhether to enable parallel function calling during tool use.
-
required_action: object { submit_tool_outputs, type }Details on the action required to continue the run. Will be
nullif no action is required.-
submit_tool_outputs: object { tool_calls }Details on the tool outputs needed for this run to continue.
-
tool_calls: array of RequiredActionFunctionToolCallA list of the relevant tool calls.
-
id: stringThe ID of the tool call. This ID must be referenced when you submit the tool outputs in using the Submit tool outputs to run endpoint.
-
function: object { arguments, name }The function definition.
-
arguments: stringThe arguments that the model expects you to pass to the function.
-
name: stringThe name of the function.
-
-
type: "function"The type of tool call the output is required for. For now, this is always
function."function"
-
-
-
type: "submit_tool_outputs"For now, this is always
submit_tool_outputs."submit_tool_outputs"
-
-
response_format: AssistantResponseFormatOptionSpecifies the format that the model must output. Compatible with GPT-4o, GPT-4 Turbo, and all GPT-3.5 Turbo models since
gpt-3.5-turbo-1106.Setting to
{ "type": "json_schema", "json_schema": {...} }enables Structured Outputs which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide.Setting to
{ "type": "json_object" }enables JSON mode, which ensures the message the model generates is valid JSON.Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly "stuck" request. Also note that the message content may be partially cut off if
finish_reason="length", which indicates the generation exceededmax_tokensor the conversation exceeded the max context length.-
"auto"autois the default value"auto"
-
ResponseFormatText object { type }Default response format. Used to generate text responses.
-
type: "text"The type of response format being defined. Always
text."text"
-
-
ResponseFormatJSONObject object { type }JSON object response format. An older method of generating JSON responses. Using
json_schemais recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.-
type: "json_object"The type of response format being defined. Always
json_object."json_object"
-
-
ResponseFormatJSONSchema object { json_schema, type }JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.
-
json_schema: object { name, description, schema, strict }Structured Outputs configuration options, including a JSON Schema.
-
name: stringThe name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
description: optional stringA description of what the response format is for, used by the model to determine how to respond in the format.
-
schema: optional map[unknown]The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
-
strict: optional booleanWhether to enable strict schema adherence when generating the output. If set to true, the model will always follow the exact schema defined in the
schemafield. Only a subset of JSON Schema is supported whenstrictistrue. To learn more, read the Structured Outputs guide.
-
-
type: "json_schema"The type of response format being defined. Always
json_schema."json_schema"
-
-
-
started_at: numberThe Unix timestamp (in seconds) for when the run was started.
-
status: "queued" or "in_progress" or "requires_action" or 6 moreThe status of the run, which can be either
queued,in_progress,requires_action,cancelling,cancelled,failed,completed,incomplete, orexpired.-
"queued" -
"in_progress" -
"requires_action" -
"cancelling" -
"cancelled" -
"failed" -
"completed" -
"incomplete" -
"expired"
-
-
thread_id: stringThe ID of the thread that was executed on as a part of this run.
-
tool_choice: AssistantToolChoiceOptionControls which (if any) tool is called by the model.
nonemeans the model will not call any tools and instead generates a message.autois the default value and means the model can pick between generating a message or calling one or more tools.requiredmeans the model must call one or more tools before responding to the user. Specifying a particular tool like{"type": "file_search"}or{"type": "function", "function": {"name": "my_function"}}forces the model to call that tool.-
"none" or "auto" or "required"nonemeans the model will not call any tools and instead generates a message.automeans the model can pick between generating a message or calling one or more tools.requiredmeans the model must call one or more tools before responding to the user.-
"none" -
"auto" -
"required"
-
-
AssistantToolChoice object { type, function }Specifies a tool the model should use. Use to force the model to call a specific tool.
-
type: "function" or "code_interpreter" or "file_search"The type of the tool. If type is
function, the function name must be set-
"function" -
"code_interpreter" -
"file_search"
-
-
function: optional AssistantToolChoiceFunction-
name: stringThe name of the function to call.
-
-
-
-
tools: array of CodeInterpreterTool or FileSearchTool or FunctionToolThe list of tools that the assistant used for this run.
-
CodeInterpreterTool object { type }-
type: "code_interpreter"The type of tool being defined:
code_interpreter"code_interpreter"
-
-
FileSearchTool object { type, file_search }-
type: "file_search"The type of tool being defined:
file_search"file_search"
-
file_search: optional object { max_num_results, ranking_options }Overrides for the file search tool.
-
max_num_results: optional numberThe maximum number of results the file search tool should output. The default is 20 for
gpt-4*models and 5 forgpt-3.5-turbo. This number should be between 1 and 50 inclusive.Note that the file search tool may output fewer than
max_num_resultsresults. See the file search tool documentation for more information. -
ranking_options: optional object { score_threshold, ranker }The ranking options for the file search. If not specified, the file search tool will use the
autoranker and a score_threshold of 0.See the file search tool documentation for more information.
-
score_threshold: numberThe score threshold for the file search. All values must be a floating point number between 0 and 1.
-
ranker: optional "auto" or "default_2024_08_21"The ranker to use for the file search. If not specified will use the
autoranker.-
"auto" -
"default_2024_08_21"
-
-
-
-
-
FunctionTool object { function, type }-
function: FunctionDefinition-
name: stringThe name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
description: optional stringA description of what the function does, used by the model to choose when and how to call the function.
-
parameters: optional FunctionParametersThe parameters the functions accepts, described as a JSON Schema object. See the guide for examples, and the JSON Schema reference for documentation about the format.
Omitting
parametersdefines a function with an empty parameter list. -
strict: optional booleanWhether to enable strict schema adherence when generating the function call. If set to true, the model will follow the exact schema defined in the
parametersfield. Only a subset of JSON Schema is supported whenstrictistrue. Learn more about Structured Outputs in the function calling guide.
-
-
type: "function"The type of tool being defined:
function"function"
-
-
-
truncation_strategy: object { type, last_messages }Controls for how a thread will be truncated prior to the run. Use this to control the initial context window of the run.
-
type: "auto" or "last_messages"The truncation strategy to use for the thread. The default is
auto. If set tolast_messages, the thread will be truncated to the n most recent messages in the thread. When set toauto, messages in the middle of the thread will be dropped to fit the context length of the model,max_prompt_tokens.-
"auto" -
"last_messages"
-
-
last_messages: optional numberThe number of most recent messages from the thread when constructing the context for the run.
-
-
usage: object { completion_tokens, prompt_tokens, total_tokens }Usage statistics related to the run. This value will be
nullif the run is not in a terminal state (i.e.in_progress,queued, etc.).-
completion_tokens: numberNumber of completion tokens used over the course of the run.
-
prompt_tokens: numberNumber of prompt tokens used over the course of the run.
-
total_tokens: numberTotal number of tokens used (prompt + completion).
-
-
temperature: optional numberThe sampling temperature used for this run. If not set, defaults to 1.
-
top_p: optional numberThe nucleus sampling value used for this run. If not set, defaults to 1.
-
-
event: "thread.run.created""thread.run.created"
-
-
object { data, event }Occurs when a run moves to a
queuedstatus.-
data: RunRepresents an execution run on a thread.
-
event: "thread.run.queued""thread.run.queued"
-
-
object { data, event }Occurs when a run moves to an
in_progressstatus.-
data: RunRepresents an execution run on a thread.
-
event: "thread.run.in_progress""thread.run.in_progress"
-
-
object { data, event }Occurs when a run moves to a
requires_actionstatus.-
data: RunRepresents an execution run on a thread.
-
event: "thread.run.requires_action""thread.run.requires_action"
-
-
object { data, event }Occurs when a run is completed.
-
data: RunRepresents an execution run on a thread.
-
event: "thread.run.completed""thread.run.completed"
-
-
object { data, event }Occurs when a run ends with status
incomplete.-
data: RunRepresents an execution run on a thread.
-
event: "thread.run.incomplete""thread.run.incomplete"
-
-
object { data, event }Occurs when a run fails.
-
data: RunRepresents an execution run on a thread.
-
event: "thread.run.failed""thread.run.failed"
-
-
object { data, event }Occurs when a run moves to a
cancellingstatus.-
data: RunRepresents an execution run on a thread.
-
event: "thread.run.cancelling""thread.run.cancelling"
-
-
object { data, event }Occurs when a run is cancelled.
-
data: RunRepresents an execution run on a thread.
-
event: "thread.run.cancelled""thread.run.cancelled"
-
-
object { data, event }Occurs when a run expires.
-
data: RunRepresents an execution run on a thread.
-
event: "thread.run.expired""thread.run.expired"
-
-
object { data, event }Occurs when a run step is created.
-
data: RunStepRepresents a step in execution of a run.
-
id: stringThe identifier of the run step, which can be referenced in API endpoints.
-
assistant_id: stringThe ID of the assistant associated with the run step.
-
cancelled_at: numberThe Unix timestamp (in seconds) for when the run step was cancelled.
-
completed_at: numberThe Unix timestamp (in seconds) for when the run step completed.
-
created_at: numberThe Unix timestamp (in seconds) for when the run step was created.
-
expired_at: numberThe Unix timestamp (in seconds) for when the run step expired. A step is considered expired if the parent run is expired.
-
failed_at: numberThe Unix timestamp (in seconds) for when the run step failed.
-
last_error: object { code, message }The last error associated with this run step. Will be
nullif there are no errors.-
code: "server_error" or "rate_limit_exceeded"One of
server_errororrate_limit_exceeded.-
"server_error" -
"rate_limit_exceeded"
-
-
message: stringA human-readable description of the error.
-
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
object: "thread.run.step"The object type, which is always
thread.run.step."thread.run.step"
-
run_id: stringThe ID of the run that this run step is a part of.
-
status: "in_progress" or "cancelled" or "failed" or 2 moreThe status of the run step, which can be either
in_progress,cancelled,failed,completed, orexpired.-
"in_progress" -
"cancelled" -
"failed" -
"completed" -
"expired"
-
-
step_details: MessageCreationStepDetails or ToolCallsStepDetailsThe details of the run step.
-
MessageCreationStepDetails object { message_creation, type }Details of the message creation by the run step.
-
message_creation: object { message_id }-
message_id: stringThe ID of the message that was created by this run step.
-
-
type: "message_creation"Always
message_creation."message_creation"
-
-
ToolCallsStepDetails object { tool_calls, type }Details of the tool call.
-
tool_calls: array of CodeInterpreterToolCall or FileSearchToolCall or FunctionToolCallAn array of tool calls the run step was involved in. These can be associated with one of three types of tools:
code_interpreter,file_search, orfunction.-
CodeInterpreterToolCall object { id, code_interpreter, type }Details of the Code Interpreter tool call the run step was involved in.
-
id: stringThe ID of the tool call.
-
code_interpreter: object { input, outputs }The Code Interpreter tool call definition.
-
input: stringThe input to the Code Interpreter tool call.
-
outputs: array of object { logs, type } or object { image, type }The outputs from the Code Interpreter tool call. Code Interpreter can output one or more items, including text (
logs) or images (image). Each of these are represented by a different object type.-
CodeInterpreterLogOutput object { logs, type }Text output from the Code Interpreter tool call as part of a run step.
-
logs: stringThe text output from the Code Interpreter tool call.
-
type: "logs"Always
logs."logs"
-
-
CodeInterpreterImageOutput object { image, type }-
image: object { file_id }-
file_id: stringThe file ID of the image.
-
-
type: "image"Always
image."image"
-
-
-
-
type: "code_interpreter"The type of tool call. This is always going to be
code_interpreterfor this type of tool call."code_interpreter"
-
-
FileSearchToolCall object { id, file_search, type }-
id: stringThe ID of the tool call object.
-
file_search: object { ranking_options, results }For now, this is always going to be an empty object.
-
ranking_options: optional object { ranker, score_threshold }The ranking options for the file search.
-
ranker: "auto" or "default_2024_08_21"The ranker to use for the file search. If not specified will use the
autoranker.-
"auto" -
"default_2024_08_21"
-
-
score_threshold: numberThe score threshold for the file search. All values must be a floating point number between 0 and 1.
-
-
results: optional array of object { file_id, file_name, score, content }The results of the file search.
-
file_id: stringThe ID of the file that result was found in.
-
file_name: stringThe name of the file that result was found in.
-
score: numberThe score of the result. All values must be a floating point number between 0 and 1.
-
content: optional array of object { text, type }The content of the result that was found. The content is only included if requested via the include query parameter.
-
text: optional stringThe text content of the file.
-
type: optional "text"The type of the content.
"text"
-
-
-
-
type: "file_search"The type of tool call. This is always going to be
file_searchfor this type of tool call."file_search"
-
-
FunctionToolCall object { id, function, type }-
id: stringThe ID of the tool call object.
-
function: object { arguments, name, output }The definition of the function that was called.
-
arguments: stringThe arguments passed to the function.
-
name: stringThe name of the function.
-
output: stringThe output of the function. This will be
nullif the outputs have not been submitted yet.
-
-
type: "function"The type of tool call. This is always going to be
functionfor this type of tool call."function"
-
-
-
type: "tool_calls"Always
tool_calls."tool_calls"
-
-
-
thread_id: stringThe ID of the thread that was run.
-
type: "message_creation" or "tool_calls"The type of run step, which can be either
message_creationortool_calls.-
"message_creation" -
"tool_calls"
-
-
usage: object { completion_tokens, prompt_tokens, total_tokens }Usage statistics related to the run step. This value will be
nullwhile the run step's status isin_progress.-
completion_tokens: numberNumber of completion tokens used over the course of the run step.
-
prompt_tokens: numberNumber of prompt tokens used over the course of the run step.
-
total_tokens: numberTotal number of tokens used (prompt + completion).
-
-
-
event: "thread.run.step.created""thread.run.step.created"
-
-
object { data, event }Occurs when a run step moves to an
in_progressstate.-
data: RunStepRepresents a step in execution of a run.
-
event: "thread.run.step.in_progress""thread.run.step.in_progress"
-
-
object { data, event }Occurs when parts of a run step are being streamed.
-
data: RunStepDeltaEventRepresents a run step delta i.e. any changed fields on a run step during streaming.
-
id: stringThe identifier of the run step, which can be referenced in API endpoints.
-
delta: object { step_details }The delta containing the fields that have changed on the run step.
-
step_details: optional RunStepDeltaMessageDelta or ToolCallDeltaObjectThe details of the run step.
-
RunStepDeltaMessageDelta object { type, message_creation }Details of the message creation by the run step.
-
type: "message_creation"Always
message_creation."message_creation"
-
message_creation: optional object { message_id }-
message_id: optional stringThe ID of the message that was created by this run step.
-
-
-
ToolCallDeltaObject object { type, tool_calls }Details of the tool call.
-
type: "tool_calls"Always
tool_calls."tool_calls"
-
tool_calls: optional array of CodeInterpreterToolCallDelta or FileSearchToolCallDelta or FunctionToolCallDeltaAn array of tool calls the run step was involved in. These can be associated with one of three types of tools:
code_interpreter,file_search, orfunction.-
CodeInterpreterToolCallDelta object { index, type, id, code_interpreter }Details of the Code Interpreter tool call the run step was involved in.
-
index: numberThe index of the tool call in the tool calls array.
-
type: "code_interpreter"The type of tool call. This is always going to be
code_interpreterfor this type of tool call."code_interpreter"
-
id: optional stringThe ID of the tool call.
-
code_interpreter: optional object { input, outputs }The Code Interpreter tool call definition.
-
input: optional stringThe input to the Code Interpreter tool call.
-
outputs: optional array of CodeInterpreterLogs or CodeInterpreterOutputImageThe outputs from the Code Interpreter tool call. Code Interpreter can output one or more items, including text (
logs) or images (image). Each of these are represented by a different object type.-
CodeInterpreterLogs object { index, type, logs }Text output from the Code Interpreter tool call as part of a run step.
-
index: numberThe index of the output in the outputs array.
-
type: "logs"Always
logs."logs"
-
logs: optional stringThe text output from the Code Interpreter tool call.
-
-
CodeInterpreterOutputImage object { index, type, image }-
index: numberThe index of the output in the outputs array.
-
type: "image"Always
image."image"
-
image: optional object { file_id }-
file_id: optional stringThe file ID of the image.
-
-
-
-
-
-
FileSearchToolCallDelta object { file_search, index, type, id }-
file_search: unknownFor now, this is always going to be an empty object.
-
index: numberThe index of the tool call in the tool calls array.
-
type: "file_search"The type of tool call. This is always going to be
file_searchfor this type of tool call."file_search"
-
id: optional stringThe ID of the tool call object.
-
-
FunctionToolCallDelta object { index, type, id, function }-
index: numberThe index of the tool call in the tool calls array.
-
type: "function"The type of tool call. This is always going to be
functionfor this type of tool call."function"
-
id: optional stringThe ID of the tool call object.
-
function: optional object { arguments, name, output }The definition of the function that was called.
-
arguments: optional stringThe arguments passed to the function.
-
name: optional stringThe name of the function.
-
output: optional stringThe output of the function. This will be
nullif the outputs have not been submitted yet.
-
-
-
-
-
-
-
object: "thread.run.step.delta"The object type, which is always
thread.run.step.delta."thread.run.step.delta"
-
-
event: "thread.run.step.delta""thread.run.step.delta"
-
-
object { data, event }Occurs when a run step is completed.
-
data: RunStepRepresents a step in execution of a run.
-
event: "thread.run.step.completed""thread.run.step.completed"
-
-
object { data, event }Occurs when a run step fails.
-
data: RunStepRepresents a step in execution of a run.
-
event: "thread.run.step.failed""thread.run.step.failed"
-
-
object { data, event }Occurs when a run step is cancelled.
-
data: RunStepRepresents a step in execution of a run.
-
event: "thread.run.step.cancelled""thread.run.step.cancelled"
-
-
object { data, event }Occurs when a run step expires.
-
data: RunStepRepresents a step in execution of a run.
-
event: "thread.run.step.expired""thread.run.step.expired"
-
-
object { data, event }Occurs when a message is created.
-
data: MessageRepresents a message within a thread.
-
id: stringThe identifier, which can be referenced in API endpoints.
-
assistant_id: stringIf applicable, the ID of the assistant that authored this message.
-
attachments: array of object { file_id, tools }A list of files attached to the message, and the tools they were added to.
-
file_id: optional stringThe ID of the file to attach to the message.
-
tools: optional array of CodeInterpreterTool or object { type }The tools to add this file to.
-
CodeInterpreterTool object { type } -
FileSearchTool object { type }-
type: "file_search"The type of tool being defined:
file_search"file_search"
-
-
-
-
completed_at: numberThe Unix timestamp (in seconds) for when the message was completed.
-
content: array of ImageFileContentBlock or ImageURLContentBlock or TextContentBlock or RefusalContentBlockThe content of the message in array of text and/or images.
-
ImageFileContentBlock object { image_file, type }References an image File in the content of a message.
-
image_file: ImageFile-
file_id: stringThe File ID of the image in the message content. Set
purpose="vision"when uploading the File if you need to later display the file content. -
detail: optional "auto" or "low" or "high"Specifies the detail level of the image if specified by the user.
lowuses fewer tokens, you can opt in to high resolution usinghigh.-
"auto" -
"low" -
"high"
-
-
-
type: "image_file"Always
image_file."image_file"
-
-
ImageURLContentBlock object { image_url, type }References an image URL in the content of a message.
-
image_url: ImageURL-
url: stringThe external URL of the image, must be a supported image types: jpeg, jpg, png, gif, webp.
-
detail: optional "auto" or "low" or "high"Specifies the detail level of the image.
lowuses fewer tokens, you can opt in to high resolution usinghigh. Default value isauto-
"auto" -
"low" -
"high"
-
-
-
type: "image_url"The type of the content part.
"image_url"
-
-
TextContentBlock object { text, type }The text content that is part of a message.
-
text: Text-
annotations: array of FileCitationAnnotation or FilePathAnnotation-
FileCitationAnnotation object { end_index, file_citation, start_index, 2 more }A citation within the message that points to a specific quote from a specific File associated with the assistant or the message. Generated when the assistant uses the "file_search" tool to search files.
-
end_index: number -
file_citation: object { file_id }-
file_id: stringThe ID of the specific File the citation is from.
-
-
start_index: number -
text: stringThe text in the message content that needs to be replaced.
-
type: "file_citation"Always
file_citation."file_citation"
-
-
FilePathAnnotation object { end_index, file_path, start_index, 2 more }A URL for the file that's generated when the assistant used the
code_interpretertool to generate a file.-
end_index: number -
file_path: object { file_id }-
file_id: stringThe ID of the file that was generated.
-
-
start_index: number -
text: stringThe text in the message content that needs to be replaced.
-
type: "file_path"Always
file_path."file_path"
-
-
-
value: stringThe data that makes up the text.
-
-
type: "text"Always
text."text"
-
-
RefusalContentBlock object { refusal, type }The refusal content generated by the assistant.
-
refusal: string -
type: "refusal"Always
refusal."refusal"
-
-
-
created_at: numberThe Unix timestamp (in seconds) for when the message was created.
-
incomplete_at: numberThe Unix timestamp (in seconds) for when the message was marked as incomplete.
-
incomplete_details: object { reason }On an incomplete message, details about why the message is incomplete.
-
reason: "content_filter" or "max_tokens" or "run_cancelled" or 2 moreThe reason the message is incomplete.
-
"content_filter" -
"max_tokens" -
"run_cancelled" -
"run_expired" -
"run_failed"
-
-
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
object: "thread.message"The object type, which is always
thread.message."thread.message"
-
role: "user" or "assistant"The entity that produced the message. One of
userorassistant.-
"user" -
"assistant"
-
-
run_id: stringThe ID of the run associated with the creation of this message. Value is
nullwhen messages are created manually using the create message or create thread endpoints. -
status: "in_progress" or "incomplete" or "completed"The status of the message, which can be either
in_progress,incomplete, orcompleted.-
"in_progress" -
"incomplete" -
"completed"
-
-
thread_id: stringThe thread ID that this message belongs to.
-
-
event: "thread.message.created""thread.message.created"
-
-
object { data, event }Occurs when a message moves to an
in_progressstate.-
data: MessageRepresents a message within a thread.
-
event: "thread.message.in_progress""thread.message.in_progress"
-
-
object { data, event }Occurs when parts of a Message are being streamed.
-
data: MessageDeltaEventRepresents a message delta i.e. any changed fields on a message during streaming.
-
id: stringThe identifier of the message, which can be referenced in API endpoints.
-
delta: MessageDeltaThe delta containing the fields that have changed on the Message.
-
content: optional array of ImageFileDeltaBlock or TextDeltaBlock or RefusalDeltaBlock or ImageURLDeltaBlockThe content of the message in array of text and/or images.
-
ImageFileDeltaBlock object { index, type, image_file }References an image File in the content of a message.
-
index: numberThe index of the content part in the message.
-
type: "image_file"Always
image_file."image_file"
-
image_file: optional ImageFileDelta-
detail: optional "auto" or "low" or "high"Specifies the detail level of the image if specified by the user.
lowuses fewer tokens, you can opt in to high resolution usinghigh.-
"auto" -
"low" -
"high"
-
-
file_id: optional stringThe File ID of the image in the message content. Set
purpose="vision"when uploading the File if you need to later display the file content.
-
-
-
TextDeltaBlock object { index, type, text }The text content that is part of a message.
-
index: numberThe index of the content part in the message.
-
type: "text"Always
text."text"
-
text: optional TextDelta-
annotations: optional array of FileCitationDeltaAnnotation or FilePathDeltaAnnotation-
FileCitationDeltaAnnotation object { index, type, end_index, 3 more }A citation within the message that points to a specific quote from a specific File associated with the assistant or the message. Generated when the assistant uses the "file_search" tool to search files.
-
index: numberThe index of the annotation in the text content part.
-
type: "file_citation"Always
file_citation."file_citation"
-
end_index: optional number -
file_citation: optional object { file_id, quote }-
file_id: optional stringThe ID of the specific File the citation is from.
-
quote: optional stringThe specific quote in the file.
-
-
start_index: optional number -
[...]
